function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}
import { PrimaryColumn, Entity, JoinColumn, Column, ManyToOne, Index } from "typeorm";
import { User } from "./user.js";
import { id } from "../id.js";
export let UserSecurityKey = class UserSecurityKey {
    id;
    userId;
    user;
    publicKey;
    lastUsed;
    name;
    constructor(data){
        if (data == null) return;
        for (const [k, v] of Object.entries(data)){
            this[k] = v;
        }
    }
};
_ts_decorate([
    PrimaryColumn("varchar", {
        comment: "Variable-length id given to navigator.credentials.get()"
    }),
    _ts_metadata("design:type", String)
], UserSecurityKey.prototype, "id", void 0);
_ts_decorate([
    Index(),
    Column(id()),
    _ts_metadata("design:type", Object)
], UserSecurityKey.prototype, "userId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], UserSecurityKey.prototype, "user", void 0);
_ts_decorate([
    Index(),
    Column("varchar", {
        comment: "Variable-length public key used to verify attestations (hex-encoded)."
    }),
    _ts_metadata("design:type", String)
], UserSecurityKey.prototype, "publicKey", void 0);
_ts_decorate([
    Column("timestamp with time zone", {
        comment: "The date of the last time the UserSecurityKey was successfully validated."
    }),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], UserSecurityKey.prototype, "lastUsed", void 0);
_ts_decorate([
    Column("varchar", {
        comment: "User-defined name for this key",
        length: 30
    }),
    _ts_metadata("design:type", String)
], UserSecurityKey.prototype, "name", void 0);
UserSecurityKey = _ts_decorate([
    Entity(),
    _ts_metadata("design:type", Function),
    _ts_metadata("design:paramtypes", [
        typeof Partial === "undefined" ? Object : Partial
    ])
], UserSecurityKey);
